.686p
.model  flat, stdcall
option Casemap :None    
.nolist
include windows.inc

uselib  MACRO   libname
    include     libname.inc
    includelib  libname.lib
ENDM
uselib user32
uselib kernel32
uselib comctl32
uselib gdi32

inv equ invoke

DIBX struct
   hDib  dword ? ; handle to dib
   pBits dword ? ; address of start of bit info
   sBIH  BITMAPINFOHEADER <> 
DIBX ends

.list
.data
ClassName       DB "StdWindow",0
szAppName       DB "Test",0
wc WNDCLASS <CS_HREDRAW or CS_VREDRAW,WndProc,0,0,0,0,0,COLOR_WINDOW+1,0,ClassName>

SizeArea   RECT <0,0,100,100>

.data?
hInst   dd ?
hWindow dd ?
hWin    dd ?
hwindow dd ?
hDC     dd ? 
MessageOS  MSG <>

DibClient  DIBX <>
DibBackUp  DIBX <> ; main back buffer dib (device independant bitmap) (hidden buffer 1)
DibCursor  DIBX <> ; mouse cursor dib, 100 x 100

ClientArea RECT <>
CursorArea RECT <>
BackUpArea RECT <>

;mwidth  equ ClientArea.right  ; total width of client rectangle in pixels
;mheight equ ClientArea.bottom ; total height in pixels

.code
Program:
    inv GetModuleHandle,0
    mov hInst,eax
    mov wc.hInstance,eax   ; save for later
    inv LoadIcon,0,IDI_APPLICATION
    mov wc.hIcon,eax
    inv LoadCursor,0,IDC_ARROW
    mov wc.hCursor,eax
    inv RegisterClass,ADDR wc
    inv CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName,ADDR szAppName,WS_OVERLAPPEDWINDOW,
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,hInst,0
    mov hWindow,eax
    inv ShowWindow,hWindow,SW_SHOWNORMAL
    inv UpdateWindow,hWindow
    .repeat
        inv GetMessage,ADDR MessageOS,0,0,0
        .break .if !eax
        inv TranslateMessage,ADDR MessageOS
        inv DispatchMessage,ADDR MessageOS
    .until 0
    inv ExitProcess,MessageOS.wParam


;.data?


.code
;
MakeDibSection PROC uses edi MdsDib,MdsWidth,MdsHeight ; create dib section. MdsDib=address of DIBX structure
                                      ; MdsWidth is the width, MdsHeight is the height
    mov edi,MdsDib
    mov eax,(DIBX PTR [edi]).hDib
    .if eax
        inv DeleteObject,eax    ; delete old dib
    .endif
    mov ecx,SIZEOF DIBX ; clear out any old data
    mov eax,0
    rep stosb
    mov edi,MdsDib
    mov eax,MdsWidth
    mov (DIBX PTR [edi]).sBIH.biWidth,eax  ; set width and height in bitmapinfoheader
    mov eax,MdsHeight
    neg eax
    mov (DIBX PTR [edi]).sBIH.biHeight,eax
    mov (DIBX PTR [edi]).sBIH.biSize,SIZEOF BITMAPINFOHEADER
    mov (DIBX PTR [edi]).sBIH.biPlanes,1
    mov (DIBX PTR [edi]).sBIH.biBitCount,32
    mov (DIBX PTR [edi]).sBIH.biCompression,BI_RGB
    lea eax,(DIBX PTR [edi]).pBits
    lea edx,(DIBX PTR [edi]).sBIH
    inv CreateDIBSection,0,edx,DIB_RGB_COLORS,eax,0,0
    mov (DIBX PTR [edi]).hDib,eax

    ret
MakeDibSection ENDP


.data
fmtx6 db "%li %li %li %li %li %li",0
fmtx1 db " %li "
.data?
buffx db 1024 dup (?)
.code
;
WndProc PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    local tdc,ccnt,cloc,rloc

    .if uMsg==WM_CREATE
        mov eax,hWnd
        mov hWin,eax
        mov eax,SizeArea.left
        mov edx,SizeArea.top
        mov BackUpArea.left,eax
        mov BackUpArea.top,edx
        mov CursorArea.left,eax
        mov CursorArea.top,edx
        mov eax,SizeArea.right
        mov edx,SizeArea.bottom
        mov BackUpArea.right,eax
        mov BackUpArea.bottom,edx
        mov CursorArea.right,eax
        mov CursorArea.bottom,edx
        inv GetClientRect,hWin,ADDR ClientArea    ; get the size needed for the bitmap
        inv MakeDibSection,ADDR DibClient,ClientArea.right,ClientArea.bottom
        inv MakeDibSection,ADDR DibCursor,CursorArea.right,CursorArea.bottom
        inv MakeDibSection,ADDR DibBackUp,BackUpArea.right,BackUpArea.bottom
        mov eax,0ffffbfh     ; fill hidden screen buffer with a color
        mov ecx,ClientArea.right
        imul ecx,ClientArea.bottom
        push edi
        mov edi,DibClient.pBits
        rep stosd
        pop edi
        inv GetDC,hWin
        mov hDC,eax
        inv CreateCompatibleDC,hDC
        mov tdc,eax
        inv ReleaseDC,hWin,hDC
        inv SelectObject,tdc,DibClient.hDib
        inv SetBkMode,tdc,TRANSPARENT
        mov ccnt,0
        mov rloc,0
        mov cloc,0
        .repeat
            inv wsprintf,ADDR buffx,ADDR fmtx1,ccnt
            ;inv DrawText,tdc,ADDR buffx,-1,ADDR tt,0
            inv TextOut,tdc,cloc,rloc,ADDR buffx,eax
            add ccnt,1
            add cloc,44
            mov eax,ClientArea.right
            .if cloc  > eax
                add rloc,17
                mov cloc,0
                mov eax,ClientArea.bottom
                .break .if rloc > eax
            .endif
        .until 0
        inv DeleteDC,tdc
        call UpdateScreen
    .elseif uMsg==WM_PAINT
        call UpdateScreen 
    .elseif uMsg == WM_SETCURSOR
        call SetMouseCursorImage
    .elseif uMsg==WM_CLOSE
        ; do cleanup here
    .elseif uMsg==WM_DESTROY
        inv PostQuitMessage,0
        mov eax,wParam
        jmp WndRet
    .endif
    inv DefWindowProc,hWnd,uMsg,wParam,lParam
WndRet:

    ret
WndProc ENDP


.code
;
UpdateScreen PROC

    inv GetDC,hWin
    mov hDC,eax
    inv SetDIBitsToDevice,hDC,ClientArea.left,ClientArea.top,ClientArea.right,ClientArea.bottom,0,0,0,ClientArea.bottom,DibClient.pBits,ADDR DibClient.sBIH,DIB_RGB_COLORS
    inv ReleaseDC,hWin,hDC

    ret
UpdateScreen ENDP


.data
FirstUse db 1

.data?
CursorPos    POINT <> ; current x,y of cursor
OldCursorPos POINT <>
BackUpPos    POINT <>
BackUpSizes  POINT <>

.code
;
SetMouseCursorImage PROC

    inv GetCursorPos,ADDR CursorPos         ; maybe do on wm_mousemove or wm_ncmousemove
    inv ScreenToClient,hWin,ADDR CursorPos  ; maybe get conversion factors on resize and start
    inv SetCursor,0 ; suppress windows cursor


    mov eax,CursorPos.x   ; test the position
    mov edx,CursorPos.y
    cmp eax,OldCursorPos.x
    jne DoTheWork
    cmp edx,OldCursorPos.y
    je AvoidTheWork


DoTheWork:
        pushad   ; need lots of registers


        cmp FirstUse,1
        je AvoidRestore
        mov eax,BackUpPos.y   ; make the backup
        mul ClientArea.right     ; pixels to skip on top
        add eax,BackUpPos.x   ; pixels to skip on left
        shl eax,2       ; * 4 bytes/pixel
        mov edi,DibBackUp.pBits  ; destination
        mov esi,DibClient.pBits  ; source
        add esi,eax    ; add position
        mov ebx,BackUpSizes.y    ; our height counter
LoopRestoreHeight:
            xor ecx,ecx    ; our width counter
LoopRestoreWidth:
            mov eax,[edi+ecx*4]    ; the backup
            mov [esi+ecx*4],eax    ; the client
            add ecx,1
            cmp ecx,BackUpSizes.x
            jne LoopRestoreWidth

        mov eax,ClientArea.right
        mov ecx,BackUpArea.right   ; can use ecx only, coz same values for DibBackUp and DibCursor
        shl eax,2
        shl ecx,2
        add esi,eax
        add edi,ecx
        dec ebx
        jnz LoopRestoreHeight
AvoidRestore:


        mov eax,CursorPos.x   ; set the position for the work test
        mov ebx,CursorPos.y
        cmp eax,ClientArea.left
        jge AvoidReposLX
        mov eax,ClientArea.left
AvoidReposLX:
        cmp eax,ClientArea.right
        jl AvoidReposHX
        mov eax,ClientArea.right
AvoidReposHX:
        cmp ebx,ClientArea.top
        jge AvoidReposLY
        mov ebx,ClientArea.top
AvoidReposLY:
        cmp ebx,ClientArea.bottom
        jl AvoidReposHY
        mov ebx,ClientArea.bottom
AvoidReposHY:
        mov OldCursorPos.x,eax   ; keep the position for the work test
        mov OldCursorPos.y,ebx



;        mov eax,OldCursorPos.x   ; set the x/y/width/height for the backup (lines useless coz registers already ok)
;        mov ebx,OldCursorPos.y
        mov ecx,SizeArea.right   ; 100
        mov edx,ecx
        shr edx,1   ; 50
        sub eax,edx
        jns AvoidChangeLX
        add ecx,eax    ; corrections of lower x if needed
        mov edx,ClientArea.left
        mov BackUpSizes.x,ecx
        mov BackUpPos.x,edx
        jmp AvoidChangeX
AvoidChangeLX:
        add eax,ecx
        cmp eax,ClientArea.right
        jl AvoidChangeHX
        mov edx,ClientArea.right    ; corrections of higher x if needed
        sub eax,ecx
        sub edx,eax
        mov BackUpPos.x,eax
        mov BackUpSizes.x,edx
        jmp AvoidChangeX
AvoidChangeHX:
        sub eax,ecx    ; corrections to normal value
        mov BackUpSizes.x,ecx
        mov BackUpPos.x,eax
AvoidChangeX:
        mov ecx,SizeArea.bottom   ; 100
        mov edx,ecx
        shr edx,1   ; 50
        sub ebx,edx
        jns AvoidChangeLY
        add ecx,ebx    ; corrections of lower y if needed
        mov edx,ClientArea.top
        mov BackUpSizes.y,ecx
        mov BackUpPos.y,edx
        jmp AvoidChangeY
AvoidChangeLY:
        add ebx,ecx
        cmp ebx,ClientArea.bottom
        jl AvoidChangeHY
        mov edx,ClientArea.bottom    ; corrections of higher y if needed
        sub ebx,ecx
        sub edx,ebx
        mov BackUpPos.y,ebx
        mov BackUpSizes.y,edx
        jmp AvoidChangeY
AvoidChangeHY:
        sub ebx,ecx    ; corrections to normal value
        mov BackUpSizes.y,ecx
        mov BackUpPos.y,ebx
AvoidChangeY:


        mov eax,BackUpPos.y   ; make the new backup and the alpha in the same time
        mul ClientArea.right     ; pixels to skip on top
        add eax,BackUpPos.x   ; pixels to skip on left
        shl eax,2       ; * 4 bytes/pixel
        mov edi,DibBackUp.pBits  ; destination
        mov esi,DibClient.pBits  ; source
        add esi,eax    ; add position
        mov ebx,BackUpSizes.y    ; our height counter
LoopHeight:
            xor ecx,ecx    ; our width counter
LoopWidth:
            mov eax,[esi+ecx*4]    ; the client area
            mov [edi+ecx*4],eax    ; the backup

            bswap eax    ; to simulate an alpha

;            mov eax,[esi+ebp]
;            mov [edi+ebp],eax   ; input data
;                ; do fake alpha
;                mov ccolor,0    ; cursor color
;                mov ebx,256
;                mov ecx,128 ; simulate 50% alpha
;                mov eax,ecx ; save alpha
;                sub ebx,ecx ; 1-alpha
;                mov edx,22  ; fake blue part for test
;                movzx eax,byte ptr [esi+ebp] ; blue part of image
;                imul dx,bx      ; * (1-alpha)
;                imul ax,cx      ; * alpha
;                add ah,dh   ; = (x/256) + (y/256)
;                mov [edi+ebp],ah
;            add ebp,4

            mov [esi+ecx*4],eax    ; the cursor with alpha
            add ecx,1
            cmp ecx,BackUpSizes.x
            jne LoopWidth

        mov eax,ClientArea.right
        mov ecx,BackUpArea.right
        shl eax,2
        shl ecx,2
        add esi,eax
        add edi,ecx
        dec ebx
        jnz LoopHeight

        mov FirstUse,0


        inv wsprintf,ADDR buffx,ADDR fmtx6,OldCursorPos.x,OldCursorPos.y,BackUpSizes.x,BackUpSizes.y,ClientArea.right,ClientArea.bottom
        inv SetWindowText,hWin,ADDR buffx
        inv PostMessage,hWin,WM_PAINT,NULL,NULL

        popad

AvoidTheWork:

    ret
SetMouseCursorImage ENDP

END Program